UNW\_GET\_ELF\_FILENAME(3libunwind)

NAME
unw_get_elf_filename -- get backing elf filename

SYNOPSIS

#include <libunwind.h>

int unw_get_elf_filename(unw_cursor_t *cp, char *bufp, size_t len, unw_word_t *offp);

DESCRIPTION

The unw_get_elf_filename() routine returns the backing elf filename of the current instruction pointer that created the stack frame identified by argument cp. The bufp argument is a pointer to a character buffer that is at least len bytes long. This buffer is used to return the name of the procedure. The offp argument is a pointer to a word that is used to return the byte offset of the instruction pointer saved in the stack frame identified by cp, relative to the start of the elf file. For embedded system the symbol information may has been stripped from a program, then unw_get_proc_name() may be completely unavailable, if the host side have the unstripped program with debuginfo, then can use addr2line command tool on host to get the source file name and line number of the instruction pointer, with the elf filename in bufp and address in offp.

RETURN VALUE

On successful completion, unw_get_elf_filename() returns 0. Otherwise the negative value of one of the error codes below is returned.

THREAD AND SIGNAL SAFETY

unw_get_elf_filename() is thread safe. If cursor cp is in the local address space, this routine is also safe to use from a signal handler.

ERRORS

UNW_EUNSPEC
     An unspecified error occurred.

UNW_ENOINFO
     Libunwind was unable to determine the elf filename of the instruction pointer.

UNW_ENOMEM
     The elf filename is too long to fit in the buffer provided. A truncated version of the name has been returned.

SEE ALSO

libunwind(3libunwind), unw_get_proc_info(3libunwind) unw_get_proc_name(3libunwind) unw_get_elf_filename_by_ip(3libunwind) addr2line(1addr2line)

AUTHOR

Xiang Lin
Email: myd.xia@gmail.com